//This file is part of the LTakeshi v0.0 library written in -*- C++ -*-

//LTakeshi v0.0: a multi-platform C++ library for GUI management
//Copyright (C) Luca Saiu, 1999-2000

//This is free software; you can redistribute it and/or modify it
//under the terms of the GNU Lesser General Public License version 2.1
//as published by the Free Software Foundation.

//This software is distributed in the hope that it will be useful, but
//WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.

//You should have received a copy of the GNU Lesser General Public
//License along with this file; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.


//Luca Saiu
//------------------------------------------
//e-mail:      positrone@freemail.it
//paper mail:  Via Camporcioni, 15
//             51019 Ponte Buggianese - Pistoia
//             Italy
//telephone:   0572-635477 Italy


#ifndef _LATTRIBUTES_H
#define _LATTRIBUTES_H

//These attributes are common to many objects; use one of these if you can.
//you can define other ones using _different_ numbers grater than
//(TYPEWIDTH*1000+Type); to minimize the probability of conflicts with other
//libraries, please choose each constant using a random number generator.
//Feel free to write me and suggest any other useful attributes I did not
//think of.

//Don't modify these values! All numbers less than TYPEWIDTH*1000+Type are
//reserved for possible future use.

//Special attributes: TYPEWIDTH*100+Type..TYPEWIDTH*190+Type
#define LAEnd     TYPEWIDTH*100+LTSpecial  // Terminator; it must be the last
                                           // parameter passed to Set()

//Geometry: TYPEWIDTH*200+Type..TYPEWIDTH*290+Type
#define LAX             TYPEWIDTH*210+LTInt      // x coordinate
#define LAY             TYPEWIDTH*220+LTInt      // y coordinate
#define LAH             TYPEWIDTH*230+LTInt      // height of a widget
#define LAW             TYPEWIDTH*240+LTInt      // width of a widget
#define LAVisible       TYPEWIDTH*250+LTBool     // is this widget visible?
#define LAImage         TYPEWIDTH*260+LTString   // an image
#define LACursor        TYPEWIDTH*270+LTString   // a mouse cursor shape
#define LAIcon          TYPEWIDTH*280+LTString   // an icon
#define LAStatusBarText TYPEWIDTH*290+LTString   // status bar text

//Behavior: TYPEWIDTH*300+Type..TYPEWIDTH*390+Type
#define LAEnabled   TYPEWIDTH*300+LTBool     // is this widget activated?
#define LAModal     TYPEWIDTH*310+LTBool     // is this widget modal?

//Stored data: TYPEWIDTH*400+Type..TYPEWIDTH*590+Type
#define LAInt             TYPEWIDTH*400+LTInt    // an int value
#define LADouble          TYPEWIDTH*410+LTDouble // a double value
#define LAString          TYPEWIDTH*420+LTString // an Lstring value
#define LABool            TYPEWIDTH*430+LTBool   // a bool value
#define LAText            TYPEWIDTH*440+LTString // a text stored or displayed somewhere
#define LAFile            TYPEWIDTH*450+LTString // a file name
#define LASound           TYPEWIDTH*460+LTString // a sound effect
#define LADate            TYPEWIDTH*470+LTString // a date
#define LATime            TYPEWIDTH*480+LTString // a time
#define LAName            TYPEWIDTH*490+LTString // a name
#define LATitle           TYPEWIDTH*500+LTString // a title
#define LAMax             TYPEWIDTH*510+LTInt    // a maximum value
#define LAMin             TYPEWIDTH*520+LTInt    // a minimum value
#define LACursorPosition  TYPEWIDTH*530+LTInt    // a cursor position
#define LAUserDefinedData TYPEWIDTH*540+LTPointer// a pointer to some data

//Callback functions: TYPEWIDTH*600+Type..TYPEWIDTH*790+Type
#define LAEffect       TYPEWIDTH*600+LTCallBack // generic callback function
#define LAOnChange     TYPEWIDTH*610+LTCallBack // the value changes
#define LAOnFocus      TYPEWIDTH*620+LTCallBack // the widget is focused
#define LAOnMove       TYPEWIDTH*630+LTCallBack // the widget is moved
#define LAOnResize     TYPEWIDTH*640+LTCallBack // the widget is resized
#define LAOnMinimize   TYPEWIDTH*650+LTCallBack // the widget is minimized
#define LAOnMaximize   TYPEWIDTH*660+LTCallBack // the widget is maximized
#define LAOnKey        TYPEWIDTH*670+LTCallBack // a key is pressed
#define LAOnMouseClick TYPEWIDTH*680+LTCallBack // a mouse button is clicked
#define LAOnMouseDown  TYPEWIDTH*690+LTCallBack // a mouse button is pressed
#define LAOnMouseUp    TYPEWIDTH*700+LTCallBack // a mouse button is released
#define LAOnTime       TYPEWIDTH*710+LTCallBack // a time interval passed
#define LAOnScroll     TYPEWIDTH*720+LTCallBack // the value changes
#define LAOnMouseMove  TYPEWIDTH*730+LTCallBack // the mouse is moved
#define LAOnUnfocus    TYPEWIDTH*740+LTCallBack // the widget is un-focused
#define LAOnMouseDoubleClick TYPEWIDTH*750+LTCallBack //double-click on widget

#endif //#ifndef _LATTRIBUTES_H

