#ifndef LCOLOR_H_
#define LCOLOR_H_

#include "../Lstring/Lstring.h"

extern const int MaxLColorComponent; // defined in LColor.cc

class LColor{
public:
  // Public fields:
  int r,g,b;
  static const int MaxComponent;

  // Constructors (no need for destructors):
  LColor();
  LColor(int r,int g,int b);
  LColor(const Lstring color);
  LColor(const LColor&);

  // Overloaded operators:
  LColor& operator=(const LColor);

  // Public methods:
  const LColor Darken(double ratio=.25) const;  // A darkened version
  const LColor Lighten(double ratio=.25) const; // A lightened version
};

extern const LColor LColorRed;
extern const LColor LColorGreen;
extern const LColor LColorBlue;
extern const LColor LColorCyan;
extern const LColor LColorMagenta;
extern const LColor LColorYellow;
extern const LColor LColorWhite;
extern const LColor LColorBlack;
extern const LColor LColorGray;

#endif //#ifndef LCOLOR_H_

