#ifndef LPIXMAP_H_
#define LPIXMAP_H_

#include "LDrawable.h"

// This class has some implementation-defined fields:
#include "sysdep/LPixmap.h"

// _Everything_ is implemented in sysdep/LPixmap.cc.

class LPixmap: public LDrawable{
protected:
  // This macro expands to the declaration of system-dependant fields:
  LPIXMAP_SYSDEP_FIELDS

public:
  // Constructors and destructors:
  LPixmap();                  // default constructor
  LPixmap(const LPixmap &x);  // copy constructor
  ~LPixmap();                 // destructor

  // Public methods:

  // Depending on the implementation, drawing primitives can be just dummy
  // methods calling the ones of the LDrawable base class:
  void Clear();
  void DrawPixel(int x,int y);
  void DrawPixel(int x,int y,const LColor c);
  void DrawLine(int x1,int y1,int x2,int y2);
  void DrawLine(int x1,int y1,int x2,int y2,const LColor c);
  void DrawFullRectangle(int x1,int y1,int x2,int y2);
  void DrawFullRectangle(int x1,int y1,int x2,int y2,const LColor c);
  void DrawFullTriangle(int x1,int y1,int x2,int y2,int x3,int y3);
  void DrawFullTriangle(int x1,int y1,int x2,int y2,int x3,int y3,const LColor c);

  void SetColor(const LColor c);
  const LColor GetColor() const;

  void CopyAreaFrom(int x1dest,int y1dest,
                    LPixmap &source,int x1,int y1,int x2,int y1);
  void CopyAreaFrom(int x1dest,int y1dest,
                    LCanvas &source,int x1,int y1,int x2,int y1);

  // These methods are not available in the parent class:
  void Resize(int w,int h);
  int GetWidth() const;
  int GetHeight() const;
};

#endif //#ifndef LPIXMAP_H_

