#ifndef XLDRAWABLE_H_
#define XLDRAWABLE_H_

#include <X11/Xlib.h>      // for Drawable GC, Xevent... types
#include <X11/Intrinsic.h> // for Widget, ... types

// Definition of system-dependant protected LDrawable fields:
#define LDRAWABLE_SYSDEP_FIELDS \
   Drawable drawable; /* An Xlib drawable         */                   \
   GC GraphicContext; /* An Xlib graphic context  */                   \
   friend class LCanvas;                                               \
   friend void RedrawCanvas(Widget w,XEvent *e,String *s,Cardinal *c); \
   inline unsigned long TrueColorLColor2Pixel(const LColor) const;     \
   inline const LColor TrueColorPixel2LColor(unsigned long) const;
// Notes for the X11 implementation:
//
// The 'drawable' field is not initialized in LDrawable; it's protected, so
// that it can be assigned a reasonable value in inherited classes,
// particularly in constructors.
//
// It must be the inherited class to _de-allocate_ the drawable, too;
// here I cannot know whether we are talking about a pixmap or a window.
//
// The graphic context, instead, is created and destroyed within _this_
// class.

#endif //#ifndef XLDRAWABLE_H_

